---
title: AudioBufferSourceNode.start()
slug: Web/API/AudioBufferSourceNode/start
tags:
  - API
  - Audio
  - AudioBufferSourceNode
  - Media
  - Method
  - Reference
  - Web Audio API
  - sound
  - start
---
<p>{{ APIRef("Web Audio API") }}</p>

<div>
<p>The <code>start()</code> method of the {{ domxref("AudioBufferSourceNode") }} Interface is used to schedule playback of the audio data contained in the buffer, or to begin playback immediately.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>AudioBufferSourceNode</em>.start([<em>when</em>][, <em>offset</em>][, <em>duration</em>]);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>when</code> {{optional_inline}}</dt>
 <dd>The time, in seconds, at which the sound should begin to play, in the same time coordinate system used by the {{domxref("AudioContext")}}. If <code>when</code> is less than ({{domxref("AudioContext.currentTime")}}, or if it's 0, the sound begins to play at once. <strong>The default value is 0.</strong></dd>
 <dt><code>offset</code> {{optional_inline}}</dt>
 <dd>An offset, specified as the number of seconds in the same time coordinate system as the <code>AudioContext</code>, to the time within the audio buffer that playback should begin. For example, to start playback halfway through a 10-second audio clip, <code>offset</code> should be 5. The default value, 0, will begin playback at the beginning of the audio buffer, and offsets past the end of the audio which will be played (based on the audio buffer's {{domxref("AudioBuffer.duration", "duration")}} and/or the {{domxref("AudioBufferSourceNode.loopEnd", "loopEnd")}} property) are silently clamped to the maximum value allowed. The computation of the offset into the sound is performed using the sound buffer's natural sample rate, rather than the current playback rate, so even if the sound is playing at twice its normal speed, the midway point through a 10-second audio buffer is still 5.</dd>
 <dt><code>duration</code> {{optional_inline}}</dt>
 <dd>The duration of the sound to be played, specified in seconds. If this parameter isn't specified, the sound plays until it reaches its natural conclusion or is stopped using the {{domxref("AudioScheduledSourceNode.stop", "stop()")}} method. Using this parameter is functionally identical to calling <code>start(when, offset)</code> and then calling <code>stop(when+duration)</code>.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>{{jsxref("undefined")}}.</p>

<h3 id="Exceptions">Exceptions</h3>

<dl>
 <dt><code>TypeError</code></dt>
 <dd>A negative value was specified for one or more of the three time parameters. Please don't attempt to tamper with the laws of temporal physics.</dd>
 <dt><code>InvalidStateError</code></dt>
 <dd><code>start()</code> has already been called. You can only call this function once during the lifetime of an <code>AudioBufferSourceNode</code>.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>The most simple example just starts the audio buffer playing from the beginning — you don't need to specify any parameters in this case:</p>

<pre class="brush: js">source.start();</pre>

<p>The following more complex example will, 1 second from now, start playing 10 seconds worth of sound starting 3 seconds into the audio buffer.</p>

<pre class="brush: js">source.start(audioCtx.currentTime + 1,3,10);</pre>

<div class="note">
<p>For a more complete example showing <code>start()</code> in use, check out our {{domxref("AudioContext.decodeAudioData()")}} example, You can also <a class="external external-icon" href="https://mdn.github.io/decode-audio-data/">run the code example live</a>, or <a class="external external-icon" href="https://github.com/mdn/decode-audio-data">view the source</a>.</p>
</div>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Web Audio API', '#dom-audiobuffersourcenode-start', 'start()')}}</td>
   <td>{{Spec2('Web Audio API')}}</td>
   <td> </td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.AudioBufferSourceNode.start")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Web_Audio_API/Using_Web_Audio_API">Using the Web Audio API</a></li>
</ul>
